;
; SMS Dump
; by Omar Cornut (Bock)
; Started 2002/07/28
; Last updated 2010/05/16
;

.INCLUDE "sms.inc"

; WlaDX stuffs ----------------------------------------------------------------
.EMPTYFILL $00
.SMSTAG
.COMPUTESMSCHECKSUM
.MEMORYMAP
        DEFAULTSLOT     0
        SLOTSIZE        PAGE_SIZE
        SLOT            0               PAGE_0
        SLOT            1               PAGE_1
        SLOT            2               PAGE_2 ; Unused
        SLOT            3               RAM
.ENDME

.ROMBANKMAP
        BANKSTOTAL      2
        BANKSIZE        PAGE_SIZE
        BANKS           2
.ENDRO

;------------------------------------------------------------------------------
.BANK 0 SLOT 0
;------------------------------------------------------------------------------

.DEFINE VARS    (RAM + $1800)

; Variables -------------------------------------------------------------------
.DEFINE VAR_cursor_pos          (VARS + $1)     ; 1 byte
;.DEFINE VAR_cursor_y           (VARS + $2)     ; 1 byte
.DEFINE VAR_blink_flag          (VARS + $3)     ; 1 byte
;--------------------------------------------------------
.DEFINE VAR_params_start        (VARS + $4)
.DEFINE VAR_param_0_src_slot    (VARS + $4)     ; 1 byte
.DEFINE VAR_param_1_src_mapper  (VARS + $5)     ; 1 byte
.DEFINE VAR_param_2_src_start   (VARS + $6)     ; 1 byte
.DEFINE VAR_param_3_src_address (VARS + $7)     ; 1 byte
.DEFINE VAR_param_4_src_size    (VARS + $8)     ; 1 byte
.DEFINE VAR_param_5_dst_slot    (VARS + $9)     ; 1 byte
.DEFINE VAR_param_6_dst_mapper  (VARS + $A)     ; 1 byte
.DEFINE VAR_param_7_dst_start   (VARS + $B)     ; 1 byte
.DEFINE VAR_param_8_dst_address (VARS + $C)     ; 1 byte
;--------------------------------------------------------
.DEFINE VAR_copy_src_slot       (VARS + $10)    ; 1 byte
.DEFINE VAR_copy_dst_slot       (VARS + $11)    ; 1 byte
.DEFINE VAR_copy_src_mapper     (VARS + $12)    ; 2 bytes
.DEFINE VAR_copy_dst_mapper     (VARS + $14)    ; 2 bytes
.DEFINE VAR_copy_src_address    (VARS + $16)    ; 2 bytes
.DEFINE VAR_copy_dst_address    (VARS + $18)    ; 2 bytes
.DEFINE VAR_copy_src_page_start (VARS + $1A)    ; 1 byte
.DEFINE VAR_copy_dst_page_start (VARS + $1B)    ; 1 byte
.DEFINE VAR_copy_size_left      (VARS + $1C)    ; 1 byte
;------------------------------------------------------------------------------
.DEFINE VAR_copy_src_page_current (VARS + $1D)    ; 1 byte
.DEFINE VAR_copy_dst_page_current (VARS + $1E)    ; 1 byte
.DEFINE VAR_copy_current_part   (VARS + $1F)    ; 1 byte
;------------------------------------------------------------------------------
.DEFINE VAR_hexviewer_checksum  (VARS + $20)    ; 2 bytes
.DEFINE VAR_hexviewer_page_start (VARS + $22)   ; 1 byte
.DEFINE VAR_hexviewer_byte_start (VARS + $23)   ; 2 bytes
.DEFINE VAR_hexviewer_string    (VARS + $25)    ; 32+1 bytes
;------------------------------------------------------------------------------

; Start -----------------------------------------------------------------------
.ORGA   $0000
        di
        im      1
        ld      sp,     $DFF0
        jp      start
;------------------------------------------------------------------------------

.REPT 7
        nop
.ENDR

; Tools ---------------------------------------------------------------------
.ORGA   $0010
vdp_write_de:
                ld      a, e
                out     (VDP_ADDR), a
                ld      a, d
                out     (VDP_ADDR), a
                ret
.REPT 1
        nop
.ENDR

; Note: I think that both of those are unused.

.ORGA   $0018
vdp_write_addr_de:
                ld      a, e
                out     (VDP_ADDR), a
                ld      a, d
                or      $40
                out     (VDP_ADDR), a
                ret

.REPT 7
        nop
.ENDR

.ORGA   $0028
vdp_write_addr_hl:
                ld      a, l
                out     (VDP_ADDR), a
                ld      a, h
                or      $40
                out     (VDP_ADDR), a
                ret

.REPT 7
        nop
.ENDR

; Interrupt -------------------------------------------------------------------
.ORGA   $0038
interrupt:
        di
        push    af
        in      a, (VDP_STATUS)
        pop     af
        ei
        reti
;------------------------------------------------------------------------------

.REPT   5
        nop
.ENDR

; NMI -------------------------------------------------------------------------
.ORGA   $0066
        reti
;------------------------------------------------------------------------------

; SDSC HEADER DATA ------------------------------------------------------------
sdsc_author:            .db     "Omar Cornut (Bock)", 0
sdsc_program_name:      .db     "SMS Dump", 0
sdsc_unused_but_stored: .db     "v1.00", 0
;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
start:
        call    vdp_init

        ; Set Palette
        ld      a, 0
        ld      b, 5
        ld      hl, pal_main
        call    vdp_set_pal
        ld      a, 16
        ld      b, 5
        call    vdp_set_pal

        ; Copy Font Tiles
        ld      hl, font_data
        ld      de, $0000 + VRAM_TILE_SIZE * 0
        ld      bc, font_data_end - font_data
        call    vdp_load_data

;test:
;        halt

; Make a beep
; Set pitch
;  ld a,$80
;  out ($7f),a
;  ld a,$11
;  out ($7f),a
; Set volume
;  ld a,$90
;  out ($7f),a

;        ld      hl, $C000
;        ld      de, $2000
;        ld      bc, $1FF0
;        ldir

;  ld a,$9f
;  out ($7f),a

;        jr      test

        ; Copy code to RAM
        ld      hl, $4000+64 ; bank_ram
        ld      de, bank_ram_code
        ld      bc, bank_ram_end - bank_ram_code
        ldir

        ; Print Layout
        ld      de, string_layout
        ld      hl, VRAM_BG_MAP + (0 + 0 * 32) * 2
        call    vdp_print

        ; Initialize main variable
        xor     a
        ld      (VAR_cursor_pos), a
        ld      (VAR_blink_flag), a

        ; Initialize parameters
        call    params_init
        call    params_refresh

        ; Setup VDP Registers
        ld      de, $8006               ; Nothing particular
        rst     $10
        ld      de, $81C0               ; Enable display
        rst     $10

        jp      main_loop               ; in RAM
;------------------------------------------------------------------------------

; VDP Library -----------------------------------------------------------------
.INCLUDE "vdp.asm"
;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
params_init:
        ld      hl, var_params_default
        ld      de, VAR_params_start
        ld      bc, 9
        ldir
        ret
;------------------------------------------------------------------------------

; GRAPHICS DATA ---------------------------------------------------------------
font_data:
.INCLUDE "data/data_font.inc"
font_data_end:
palette_data:
.INCLUDE "data/data_palette.inc"
palette_data_end:
;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
.BANK 1 SLOT 3 ; Code executed in RAM
;------------------------------------------------------------------------------
.ORGA   $C000
bank_ram:
.REPT 64 ; Allocate 64 bytes for variables
        nop
.ENDR

bank_ram_code:
.INCLUDE "inram.asm"
bank_ram_end:
;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
.BANK 1 SLOT 1
;------------------------------------------------------------------------------

; SDSC HEADER -----------------------------------------------------------------
.ORGA   $7FE0
        .DB     "SDSC"                  ; Magic
        .DB     $01, $00                ; Version 1.00
        .DB     $16                     ; Day
        .DB     $05                     ; Month
        .DW     $2010                   ; Year
        .DW     sdsc_author
        .DW     sdsc_program_name
        .DW     $FFFF

; CHECKSUM --------------------------------------------------------------------
;.ORGA   $7FF0
;
;       .DB     "TMR SEGA"      ; Trademark
;       .DW     $0220           ; Year
;       .DW     $0000           ; Checksum not correct
;       .DW     $0000           ; Part Num not correct
;       .DB     $00             ; Version
;       .DB     $4C             ; Master System, 32k

;------------------------------------------------------------------------------

